local dots = {
	["PRIEST"] = {
		[589] = true, -- shadow word: pain
		[34914] = true, -- vampiric touch
		[2944] = true, -- devouring plague
	}
}
local _,class = UnitClass("player")
local dotTable = dots[class]
if not dotTable then
	print("Your class is not yet supported. Load aborted.")
	return
end
local function spelldamage()
	local minDmg = GetSpellBonusDamage(2)
	for school=3,MAX_SPELL_SCHOOLS do
		local dmg = GetSpellBonusDamage(school)
		if dmg < minDmg then
			minDmg = dmg
		end
	end
	return minDmg
end
local dotDataSp = {}
local dotDataHaste = {}
local display = CreateFrame("Frame",nil,UIParent)
LOLDISPLAY = display
display:SetMovable(true)
function display:UpdateAnchor()
	self:SetPoint(self.saved.p,self.saved.n and _G[self.saved.n],self.saved.r,self.saved.x,self.saved.y)
end
display.mover = CreateFrame("Frame",nil,UIParent)
display.mover:SetFrameLevel(display:GetFrameLevel()+1)
display.mover:SetAllPoints(display)
display.mover:SetScript("OnMouseDown",function() display:StartMoving() end)
display.mover:SetScript("OnMouseUp",function() display:StopMovingOrSizing() local s,n = display.saved s.p,n,s.r,s.x,s.y = display:GetPoint() s.n = n and n:GetName() end)
display.mover:EnableMouse(true)
display.mover.tex = display.mover:CreateTexture()
display.mover.tex:SetAllPoints()
display.mover.tex:SetAlpha(0.5)
display.mover.tex:SetTexture(0.5,0.5,0.8)
display.mover.lab = display.mover:CreateFontString()
display.mover.lab:SetPoint("CENTER")
display.mover.lab:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
display.mover.lab:SetText("DotHaste:\n- Drag to move\n- /dothaste lock")
function display:UpdateLock()
	self.mover[self.saved.lock and "Hide" or "Show"](self.mover)
end
local function init()
	local keyCount = 0
	for key in pairs(dotTable) do
		local _,_,icon = GetSpellInfo(key)
		if not icon then
			display:RegisterEvent("SPELLS_CHANGED")
			return
		else
			dotDataSp[key] = dotDataSp[key] or {}
			dotDataHaste[key] = dotDataHaste[key] or {}
			dotTable[key] = icon
			keyCount = keyCount+1
		end
	end
	display:SetSize(250,50*keyCount)
	display.bars = {}
	local lastKey
	for num=1,keyCount do
		local displayBar = CreateFrame("Frame",nil,display)
		displayBar:SetSize(250,50)
		displayBar:SetPoint("TOPLEFT",0,-50*(num-1))
		displayBar.icon = displayBar:CreateTexture()
		displayBar.icon:SetPoint("TOPLEFT")
		displayBar.icon:SetSize(50,50)
		local key, tex = next(dotTable,lastKey)
		displayBar.icon:SetTexture(tex)
		displayBar.spellID = key
		lastKey = key
		displayBar.spLabel = displayBar:CreateFontString()
		displayBar.spLabel:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
		displayBar.spLabel:SetPoint("TOPLEFT",50,0)
		displayBar.spLabel:SetPoint("BOTTOMRIGHT",displayBar,"BOTTOMLEFT",150,0)
		--displayBar.spLabel:SetText(15000)
		displayBar.hasteLabel = displayBar:CreateFontString()
		displayBar.hasteLabel:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
		displayBar.hasteLabel:SetPoint("TOPLEFT",150,0)
		displayBar.hasteLabel:SetPoint("BOTTOMRIGHT")
		--displayBar.hasteLabel:SetText(4200)
		display.bars[num] = displayBar
	end
	function display:Update()
		if not (UnitExists("target") and UnitCanAttack("player","target")) then
			self:Hide()
			return
		end
		self:Show()
		local targetGUID = UnitGUID("target")
		local currentSP, currentHaste = spelldamage(), GetCombatRating(CR_HASTE_SPELL)
		for _,bar in ipairs(self.bars) do
			local id = bar.spellID
			local sp, haste = dotDataSp[id][targetGUID], dotDataHaste[id][targetGUID]
			if sp and (sp >= currentSP) then
				bar.spLabel:SetTextColor(0.4,1,0.4)
				bar.spLabel:SetText(sp)
			elseif sp then
				bar.spLabel:SetTextColor(1,1,0.4)
				bar.spLabel:SetText(currentSP)
			else
				bar.spLabel:SetText()
			end
			if haste and (haste >= currentHaste) then
				bar.hasteLabel:SetTextColor(0.4,1,0.4)
				bar.hasteLabel:SetText(haste)
			elseif haste then
				bar.hasteLabel:SetTextColor(1,1,0.4)
				bar.hasteLabel:SetText(currentHaste)
			else
				bar.hasteLabel:SetText()
			end
		end
	end
	display:Update()
	display:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	display:RegisterEvent("COMBAT_RATING_UPDATE")
	display:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
	display:RegisterEvent("PLAYER_TARGET_CHANGED")
	display:RegisterEvent("UNIT_DYNAMIC_FLAGS")
	display:RegisterEvent("UNIT_FLAGS")
	display:RegisterEvent("UNIT_FACTION")
	display:RegisterEvent("UNIT_TARGETABLE_CHANGED")
end
init()
display:SetScript("OnEvent", function(self,event,...)
	self.pguid = self.pguid or UnitGUID("player")
	if event == "SPELLS_CHANGED" then
		self:UnregisterEvent("SPELLS_CHANGED")
		init()
	elseif (event == "ADDON_LOADED") and ((...) == "DotHaste") then
		DotHaste_Saved = DotHaste_Saved or {p="CENTER",r="CENTER",n="UIParent",x=0,y=0,s=1}
		self.saved = DotHaste_Saved
		display:SetScale(self.saved.s*0.5)
		display:UpdateAnchor()
		display:UpdateLock()
		self:UnregisterEvent("ADDON_LOADED")
	elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if select(4,...) == self.pguid then
			local subEvent = select(2,...)
			if (subEvent == "SPELL_AURA_APPLIED") or (subEvent == "SPELL_AURA_REFRESH") then
				local spellID = select(12,...)
				if dotTable[spellID] then
					local sp, haste = spelldamage(), GetCombatRating(CR_HASTE_SPELL)
					local targetGUID = select(8,...)
					dotDataSp[spellID][targetGUID] = sp
					dotDataHaste[spellID][targetGUID] = haste
					display:Update()
				end
			elseif (subEvent == "SPELL_AURA_REMOVED") then
				local spellID = select(12,...)
				if dotTable[spellID] then
					local dstGUID = select(8,...)
					dotDataSp[spellID][dstGUID] = nil
					dotDataHaste[spellID][dstGUID] = nil
					display:Update()
				end
			end
		end
	else
		display:Update()
	end
end)
display:RegisterEvent("ADDON_LOADED")
LibStub("LibShorterSlash-1.0"):RegisterCommand({
	lock={
		type="handler",
		handler=function()
			display.saved.lock = not display.saved.lock
			display:UpdateLock()
		end,
	},
	scale={
		type="handler",
		handler=function(_,n)
			n = tonumber(n)
			if n then
				display:SetScale(n*0.5)
				display.saved.s = n
			end
		end,
	},
	nudge = {
		type="group";
		args={
			up = {
				type="handler",
				handler=function(_,n)
					n = tonumber(n)
					if n then
						display.saved.y = display.saved.y+n
						display:UpdateAnchor()
					end
				end,
			},
			down = {
				type = "handler",
				handler=function(_,n)
					n = tonumber(n)
					if n then
						display.saved.y = display.saved.y-n
						display:UpdateAnchor()
					end
				end,
			},
			left = {
				type = "handler",
				handler=function(_,n)
					n = tonumber(n)
					if n then
						display.saved.x = display.saved.x-n
						display:UpdateAnchor()
					end
				end,
			},
			right = {
				type = "handler",
				handler = function(_,n)
					n = tonumber(n)
					if n then
						display.saved.x = display.saved.x+n
						display:UpdateAnchor()
					end
				end,
			},
		},
	},
},"/dothaste","/dh")